/*
Purpose:    Use this to get and save the prefs through the xpcom prefs component

Handles:  Should handle default with no previous prefs

          Should handle UserName and/or Directory being  empty
*/




/*

Arguments:

    facebookUserName = string for facebook user name
    downloadDirectory = string for path to download to
    downloadImage = bool true/false
    downloadVideo = bool true/false
    downloadHTML = bool true/false
    upload2Facebook = bool true/false


*/

function savePrefs(facebookUserName, downloadDirectory, downloadImage, downloadHTML, downloadVideo, upload2Facebook)
{
    try
    {
        //instantiate xpcom pref component
        var pref_obj = Components.classes["@mozilla.org/mediadownloader;1"].createInstance(Components.interfaces.nsIMediaDownloader);
    }
    
    catch(e)
    {
        alert(e);
        alert("Prefs did not save");
        return;
    }
    
    user = facebookUserName;
    dir = downloadDirectory;
    var prefs = "";
    
    if(downloadImage){prefs += "0";}
    else{prefs += "1";}
    
    if(downloadHTML){prefs += "0";}
    else{prefs += "1";}
    
    if(downloadVideo){prefs += "0";}
    else{prefs += "1";}
    
    if(upload2Facebook){prefs += "0";}
    else{prefs += "1";}
	
    
    //account for empty strings
    if(user == "") { user = "null";}
    if(dir == "") {user = "null";}
    //call Save function in pref xpcom component
	var result = pref_obj.saveSummary(null, user, dir, prefs);
}
/*

Arguments:
    facebookUserName = string for facebook user name
    downloadDirectory = string for path to download to
    downloadImage = bool true/false
    downloadVideo = bool true/false
    downloadHTML =  bool true/false
    upload2Facebook = bool true/false


*/

function getPrefs(facebookUserName, downloadDirectory, downloadImage, downloadHTML, downloadVideo, upload2Facebook)
{

    var numPrefs = 4;
    //instantiate xpcom pref component
    
    try{
        var pref_obj = Components.classes["@mozilla.org/mediadownloader;1"].createInstance(Components.interfaces.nsIMediaDownloader);
    
        
        var user = {};
        var dir = {};
        var prefs = {};

    
        //call getPref from pref xpcom component
        var result = pref_obj.doIt(null, user, dir, prefs);
    
    }
    
    catch(e){
        alert(e);
        alert("Preferences will not be saved");
        result = false;
    }
    
    
    if(result) //check if pref file exists
    {
        //account for null strings
        if(user.value == "null") {user.value = "";}
        if(dir.value == "null") {dir.value = "";}
        
        facebookUserName.value = user.value;
        downloadDirectory.value = dir.value;
        //parse bool string from 0's and 1's in prefs into separate bool variables
        if(prefs.value.charAt(0) == "0") {downloadImage.value = true;}
        else {downloadImage.value = false;}
    
        if(prefs.value.charAt(1) == "0") {downloadHTML.value = true;}
        else {downloadHTML.value = false;}
        
        if(prefs.value.charAt(2) == "0") {downloadVideo.value = true;}
        else {downloadVideo.value = false;}
        
        if(prefs.value.charAt(3) == "0") {upload2Facebook.value = true;}
        else {upload2Facebook.value = false;}
        
    }
    
    else //go to Default if pref's aren't defined yet
    {
        facebookUserName.value = "";
        downloadDirectory.value = "";
        downloadImage.value = true;
        downloadHTML.value = false;
        downloadVideo.value = false;
        upload2Facebook.value = false;
    }
}